package eu.mikroskeem.uurimustoo.algoritmidetest.algoritmid;

import lombok.Getter;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

/**
 * @author Mark Vainomaa
 */
public class GZip extends AbstractAlgorithm {
    @Getter private final String name = "GZip";

    @Override
    public OutputStream createCompressor(OutputStream outputStream) throws IOException {
        return new GZIPOutputStream(outputStream);
    }

    @Override
    public InputStream createDecompressor(InputStream inputStream) throws IOException {
        return new GZIPInputStream(inputStream);
    }
}
