package eu.mikroskeem.uurimustoo.algoritmidetest.algoritmid;

import lombok.Getter;
import org.tukaani.xz.LZMA2Options;
import org.tukaani.xz.XZInputStream;
import org.tukaani.xz.XZOutputStream;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Mark Vainomaa
 */
public class XZ extends AbstractAlgorithm {
    @Getter private final String name = "XZ";

    @Override
    public OutputStream createCompressor(OutputStream outputStream) throws IOException {
        LZMA2Options options = new LZMA2Options();
        return new XZOutputStream(outputStream, options);
    }

    @Override
    public InputStream createDecompressor(InputStream inputStream) throws IOException {
        return new XZInputStream(inputStream);
    }
}
